#include <stdlib.h>
#include <string.h>
#include "lutil.h"
#include "xutil.h"
#include "ftn.h"
#include "nodelist.h"
#include "config.h"
#include "session.h"

extern int forcedcalls;
extern char *forcedphone;
extern char *forcedline;
#ifdef HAS_TCP
extern char *inetaddr;
#endif

extern char *get_modem_string(modem_string*,node*);
extern int openport(char*,int);
#ifdef HAS_TCP
extern int opentcp(char*);
extern void closetcp(void);
#endif
extern void localport(void);
extern void nolocalport(void);
extern void closeport(void);
extern int dialphone(node*,char*);
extern int hangup(node*);
extern void rdoptions(node*);

int call(addr)
faddr *addr;
{
	node *nlent;
	int rc=1;
	int speed;
	char *portlist,*p,*q;

	if ((nlent=getnlent(addr)) == NULL)
	{
		log("cannot call %s: fatal in nodelist lookup",
			ascfnode(addr,0x1f));
		return 1;
	}

	rdoptions(nlent);

	inbound=protinbound; /* master sessions are secure */

	if ((nlent->phone || forcedphone
#ifdef HAS_TCP
					 || inetaddr
#endif
							) &&
	    (forcedcalls || 
	     (((nlent->pflag & (DUMMY|DOWN|HOLD|PVT)) == 0) && 
	      ((localoptions & NOCALL) == 0))))
	{
		log("calling %s (%s, phone %s)",ascfnode(addr,0x1f),
			nlent->name,nlent->phone?nlent->phone:forcedphone);
#ifdef HAS_TCP
		if (inetaddr)
		{
			rc=opentcp(inetaddr);
			if (rc)
			{
				log("cannot connect %s",inetaddr);
				return rc;
			}
		}
		else
#endif
		     if (forcedline)
		{
			rc=openport(forcedline,0);
			if (rc)
			{
				log("cannot open port %s",forcedline);
				return rc;
			}
		}
		else
		{
			if ((portlist=xstrcpy(get_modem_string(modemport,nlent))) == NULL)
			{
				log("no matching ports defined");
				return 1;
			}
			for (rc=1,p=strtok(portlist," \t,");
				rc && p;
				p=strtok(NULL," \t,"))
			{
				if ((q=strrchr(p,':')))
				{
					*q++='\0';
					if ((*q == 'l') || (*q == 'L'))
					{
						speed=atoi(++q);
					}
					else
					{
						speed=atoi(q);
						if (nlent->speed < speed)
							speed=nlent->speed;
					}
				}
				else speed=0;
				rc=openport(p,speed);
			}
			if (rc)
			{
				log("no free matching ports");
				free(portlist);
				return rc;
			}
			free(portlist);
		}
#ifdef HAS_TCP
		if (!inetaddr)
#endif
		if ((rc=dialphone(nlent,forcedphone?forcedphone:nlent->phone)))
			log("dial failed");
		if (rc == 0)
		{
#ifdef HAS_TCP
			if (!inetaddr)
#endif
				nolocalport();
			rc=session(addr,nlent,SESSION_MASTER,
				SESSION_UNKNOWN,NULL);
		}
#ifdef HAS_TCP
		if (inetaddr)
		{
			closetcp();
		}
		else
#endif
		{
			localport();
			hangup(nlent);
			closeport();
		}
	}
	else
	{
		log("cannot call %s (%s, phone %s)",
			ascfnode(addr,0x1f),nlent->name,
			nlent->phone);
	}

	return rc;
}
