#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include "getopt.h"
#include "lutil.h"
#include "nodelist.h"
#include "nlindex.h"
#include "config.h"
#include "version.h"

extern int verbose;
extern char *configname;

extern int nodebld(void);

void usage(name)
char *name;
{
	fprintf(stderr,"%s\tVersion %s of %s\n\t\tCopyright (c) %s\n",
		name,version,reldate,copyright);
	fprintf(stderr,"This is free software. You can do what you wish \
with it\nas long as this copyright notice is preserved.\n\n");
	fprintf(stderr,"usage: %s -h -x<N> -I<file>\n",name);
	fprintf(stderr,"-h		get this help\n");
	fprintf(stderr,"-x<N>		set debug level to <N>	[%d]\n",
		verbose);
	fprintf(stderr,"-I<file> 	use config file	<file>	[%s]\n",
		configname);
}

int main(argc,argv)
int argc;
char *argv[];
{
	int c,rc;
	int verbset=0;
	char buf[64];

	while ((c=getopt(argc,argv,"x:l:h")) != -1)
	switch (c)
	{
		case 'x':	verbose=atoi(optarg); verbset=1; break;
		case 'I':	configname=optarg; break;
		case 'h':
		default:	usage(argv[0]); exit(1);
	}

	if ((rc=readconfig()))
	{
		fprintf(stderr,"Error getting configuration, aborting\n");
		return rc;
	}

	if (!verbset) verbose=configverbose;

	log("start %s verbose=%d",argv[0],verbose);

	rc=initnl();

	if ((rc == 0) && (isatty(0)))
	{
		printf("Nodelist index is up to date.\n");
		printf("Do you really want to rebuild it [y/N] ? ");
		fflush(stdout);
		fgets(buf,sizeof(buf)-1,stdin);
		if ((buf[0] == 'y') || (buf[0] == 'Y'))
		{
			rc=nodebld();
		}
	}
	else rc=nodebld();

	log("end %s rc=%d",argv[0],rc);

	return rc;
}
